package mod.mcreator;

import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.common.util.EnumHelper;

import net.minecraft.world.World;
import net.minecraft.potion.PotionEffect;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.Item;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.init.MobEffects;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.Minecraft;

import java.util.Random;

public class mcreator_rubyArmor {

	public mcreator_rubyArmor() {
	}

	public static Item helmet;
	public static Item body;
	public static Item legs;
	public static Item boots;
	public static Object instance;

	public void load(FMLInitializationEvent event) {
		if (event.getSide() == Side.CLIENT) {
			Minecraft.getMinecraft().getRenderItem().getItemModelMesher()
					.register(helmet, 0, new ModelResourceLocation("TestEnvironmentMod:rubyArmor_head", "inventory"));
			Minecraft.getMinecraft().getRenderItem().getItemModelMesher()
					.register(body, 0, new ModelResourceLocation("TestEnvironmentMod:rubyArmor_body", "inventory"));
			Minecraft.getMinecraft().getRenderItem().getItemModelMesher()
					.register(legs, 0, new ModelResourceLocation("TestEnvironmentMod:rubyArmor_leggins", "inventory"));
			Minecraft.getMinecraft().getRenderItem().getItemModelMesher()
					.register(boots, 0, new ModelResourceLocation("TestEnvironmentMod:rubyArmor_boots", "inventory"));
		}
		GameRegistry.addRecipe(new ItemStack(helmet, 1),
				new Object[]{"012", "3X5", "XXX", Character.valueOf('0'), mcreator_rubyGem2.block, Character.valueOf('1'), mcreator_rubyGem2.block,
						Character.valueOf('2'), mcreator_rubyGem2.block, Character.valueOf('3'), mcreator_rubyGem2.block, Character.valueOf('5'),
						mcreator_rubyGem2.block,});
		GameRegistry.addRecipe(new ItemStack(body, 1),
				new Object[]{"0X2", "345", "678", Character.valueOf('0'), mcreator_rubyGem2.block, Character.valueOf('2'), mcreator_rubyGem2.block,
						Character.valueOf('3'), mcreator_rubyGem2.block, Character.valueOf('4'), mcreator_rubyGem2.block, Character.valueOf('5'),
						mcreator_rubyGem2.block, Character.valueOf('6'), mcreator_rubyGem2.block, Character.valueOf('7'), mcreator_rubyGem2.block,
						Character.valueOf('8'), mcreator_rubyGem2.block,});
		GameRegistry.addRecipe(new ItemStack(legs, 1),
				new Object[]{"012", "3X5", "6X8", Character.valueOf('0'), mcreator_rubyGem2.block, Character.valueOf('1'), mcreator_rubyGem2.block,
						Character.valueOf('2'), mcreator_rubyGem2.block, Character.valueOf('3'), mcreator_rubyGem2.block, Character.valueOf('5'),
						mcreator_rubyGem2.block, Character.valueOf('6'), mcreator_rubyGem2.block, Character.valueOf('8'), mcreator_rubyGem2.block,});
		GameRegistry.addRecipe(new ItemStack(boots, 1),
				new Object[]{"XXX", "3X5", "6X8", Character.valueOf('3'), mcreator_rubyGem2.block, Character.valueOf('5'), mcreator_rubyGem2.block,
						Character.valueOf('6'), mcreator_rubyGem2.block, Character.valueOf('8'), mcreator_rubyGem2.block,});
		helmet.setCreativeTab(mcreator_rubyTab.tab);
		body.setCreativeTab(mcreator_rubyTab.tab);
		legs.setCreativeTab(mcreator_rubyTab.tab);
		boots.setCreativeTab(mcreator_rubyTab.tab);
	}

	public void generateNether(World world, Random random, int chunkX, int chunkZ) {
	}

	public void generateSurface(World world, Random random, int chunkX, int chunkZ) {
	}

	public int addFuel(ItemStack fuel) {
		return 0;
	}

	public void serverLoad(FMLServerStartingEvent event) {
	}

	public void preInit(FMLPreInitializationEvent event) {
	}

	public void registerRenderers() {
	}

	static {
		ItemArmor.ArmorMaterial enuma = EnumHelper.addArmorMaterial("RUBYARMOR", "rubyArmor", 40, new int[]{6, 11, 9, 7}, 15, null, 0.0f);

		int armorPreffix = 0;
		helmet = (new ItemArmor(enuma, armorPreffix, EntityEquipmentSlot.HEAD) {
			public void onArmorTick(World world, EntityPlayer entity, ItemStack itemStack) {
				int i = (int) entity.posX;
				int j = (int) entity.posY;
				int k = (int) entity.posZ;

				if (true) {
					if (entity instanceof EntityLivingBase)
						((EntityLivingBase) entity).addPotionEffect(new PotionEffect(MobEffects.REGENERATION, 0, 1));
				}
			}
		}).setUnlocalizedName("rubyArmor_head");
		helmet.setMaxStackSize(1);
		body = (new ItemArmor(enuma, armorPreffix, EntityEquipmentSlot.CHEST) {
			public void onArmorTick(World world, EntityPlayer entity, ItemStack itemStack) {
				int i = (int) entity.posX;
				int j = (int) entity.posY;
				int k = (int) entity.posZ;

				if (true) {
					if (entity instanceof EntityLivingBase)
						((EntityLivingBase) entity).addPotionEffect(new PotionEffect(MobEffects.RESISTANCE, 0, 2));
				}
			}
		}).setUnlocalizedName("rubyArmor_body");
		body.setMaxStackSize(1);
		legs = (new ItemArmor(enuma, armorPreffix, EntityEquipmentSlot.LEGS) {
			public void onArmorTick(World world, EntityPlayer entity, ItemStack itemStack) {
				int i = (int) entity.posX;
				int j = (int) entity.posY;
				int k = (int) entity.posZ;

				if (true) {
					if (entity instanceof EntityLivingBase)
						((EntityLivingBase) entity).addPotionEffect(new PotionEffect(MobEffects.SPEED, 0, 2));
				}
			}
		}).setUnlocalizedName("rubyArmor_leggins");
		legs.setMaxStackSize(1);
		boots = (new ItemArmor(enuma, armorPreffix, EntityEquipmentSlot.FEET) {
			public void onArmorTick(World world, EntityPlayer entity, ItemStack itemStack) {
				int i = (int) entity.posX;
				int j = (int) entity.posY;
				int k = (int) entity.posZ;

				if (true) {
					if (entity instanceof EntityLivingBase)
						((EntityLivingBase) entity).addPotionEffect(new PotionEffect(MobEffects.JUMP_BOOST, 0, 2));
				}
			}
		}).setUnlocalizedName("rubyArmor_boots");
		boots.setMaxStackSize(1);

		GameRegistry.registerItem(helmet, "rubyArmor_head");
		GameRegistry.registerItem(body, "rubyArmor_body");
		GameRegistry.registerItem(legs, "rubyArmor_leggins");
		GameRegistry.registerItem(boots, "rubyArmor_boots");

	}

}