package mod.mcreator;

import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.BlockFluidClassic;
import net.minecraftforge.client.model.ModelLoader;

import net.minecraft.world.World;
import net.minecraft.util.ResourceLocation;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemBucket;
import net.minecraft.item.Item;
import net.minecraft.init.Items;
import net.minecraft.client.renderer.block.statemap.StateMapperBase;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.renderer.block.model.ModelBakery;
import net.minecraft.client.renderer.ItemMeshDefinition;
import net.minecraft.block.state.IBlockState;
import net.minecraft.block.material.MaterialLiquid;
import net.minecraft.block.material.MapColor;

import java.util.Random;

public class mcreator_rubyWater {

	public static Object instance;

	static {
		FluidRegistry.enableUniversalBucket();
	}

	public mcreator_rubyWater() {
	}

	public static BlockFluidClassic block = null;
	public static ItemBucket item = null;

	public void preInit(FMLPreInitializationEvent event) {
		ResourceLocation still = new ResourceLocation("blocks/redWaterStill");
		ResourceLocation flowing = new ResourceLocation("blocks/WaterFlowing");
		Fluid fluid = new Fluid("rubywater", still, flowing).setLuminosity(13).setDensity(5000).setViscosity(3000).setGaseous(false);
		FluidRegistry.registerFluid(fluid);
		FluidRegistry.addBucketForFluid(fluid);

		block = new BlockFluidClassic(fluid, new MaterialLiquid(MapColor.AIR));
		block.setUnlocalizedName("rubyWater");
		block.setRegistryName("fluid." + block.getFluid().getName());

		GameRegistry.registerBlock(block);

		if (event.getSide() == Side.CLIENT) {
			Item item = Item.getItemFromBlock(block);
			ModelBakery.registerItemVariants(item);
			final ModelResourceLocation loc = new ModelResourceLocation("TestEnvironmentMod:rubywater", "rubywater");
			ModelLoader.setCustomMeshDefinition(item, new ItemMeshDefinition() {
				@Override
				public ModelResourceLocation getModelLocation(ItemStack stack) {
					return loc;
				}
			});
			ModelLoader.setCustomStateMapper(block, new StateMapperBase() {
				@Override
				protected ModelResourceLocation getModelResourceLocation(IBlockState state) {
					return loc;
				}
			});
		}

	}

	public void load(FMLInitializationEvent event) {

		GameRegistry.addRecipe(new ItemStack(item, 1),
				new Object[]{"0XX", "3XX", "XXX", Character.valueOf('0'), mcreator_rubyGem.block, Character.valueOf('3'), Items.WATER_BUCKET,});

	}

	public void generateNether(World world, Random random, int chunkX, int chunkZ) {
	}

	public void generateSurface(World world, Random random, int chunkX, int chunkZ) {
	}

	public int addFuel(ItemStack fuel) {
		return 0;
	}

	public void registerRenderers() {

	}

	public void serverLoad(FMLServerStartingEvent event) {
	}

}