package mod.mcreator;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.common.EnumPlantType;

import net.minecraft.world.gen.feature.WorldGenReed;
import net.minecraft.world.World;
import net.minecraft.world.IBlockAccess;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.EnumFacing;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.Minecraft;
import net.minecraft.block.state.IBlockState;
import net.minecraft.block.SoundType;
import net.minecraft.block.BlockReed;
import net.minecraft.block.Block;

import java.util.Random;

public class mcreator_tomatoPlant {

	public mcreator_tomatoPlant() {
	}

	public static Block block;

	public static Object instance;

	public void generateNether(World world, Random random, int chunkX, int chunkZ) {
	}

	public int addFuel(ItemStack fuel) {
		return 0;
	}

	public void serverLoad(FMLServerStartingEvent event) {
	}

	public void preInit(FMLPreInitializationEvent event) {
	}

	public void registerRenderers() {
	}

	public void load(FMLInitializationEvent event) {
		if (event.getSide() == Side.CLIENT) {
			Minecraft.getMinecraft().getRenderItem().getItemModelMesher()
					.register(Item.getItemFromBlock(block), 0, new ModelResourceLocation("TestEnvironmentMod:TomatoPlant", "inventory"));
		}
	}

	static {

		block = (Block) (new BlockCustomFlower()).setHardness(0.01F).setResistance(2.0F).setLightLevel(0.0F).setUnlocalizedName("TomatoPlant");
	}

	public void generateSurface(World world, java.util.Random randomGenerator, int chunkX, int chunkZ) {
		for (int i = 0; i < 20; i++) {
			int l6 = chunkX + randomGenerator.nextInt(16) + 8;
			int i11 = randomGenerator.nextInt(128);
			int l14 = chunkZ + randomGenerator.nextInt(16) + 8;
			(new WorldGenReed() {
				public boolean generate(World worldIn, Random p_180709_2_, BlockPos p_180709_3_) {
					for (int i = 0; i < 20; ++i) {
						BlockPos blockpos1 = p_180709_3_.add(p_180709_2_.nextInt(4) - p_180709_2_.nextInt(4), 0,
								p_180709_2_.nextInt(4) - p_180709_2_.nextInt(4));
						if (worldIn.isAirBlock(blockpos1)) {
							BlockPos blockpos2 = blockpos1.down();
							int j = 2 + p_180709_2_.nextInt(p_180709_2_.nextInt(3) + 1);
							for (int k = 0; k < j; ++k)
								if (((BlockReed) mcreator_tomatoPlant.block).canBlockStay(worldIn, blockpos1))
									worldIn.setBlockState(blockpos1.up(k), mcreator_tomatoPlant.block.getDefaultState(), 2);
						}
					}
					return true;
				}
			}).generate(world, randomGenerator, new BlockPos(l6, i11, l14));

		}
	}

	public static class BlockCustomFlower extends BlockReed {

		public BlockCustomFlower() {
			super();
			setSoundType(SoundType.PLANT);
			this.setCreativeTab(CreativeTabs.DECORATIONS);
			GameRegistry.registerBlock(this, "TomatoPlant");

		}

		@Override
		public EnumPlantType getPlantType(IBlockAccess world, BlockPos pos) {
			return EnumPlantType.Plains;
		}

		@Override
		public boolean canPlaceBlockAt(World worldIn, BlockPos pos) {
			Block block = worldIn.getBlockState(pos.down()).getBlock();
			return (block.canSustainPlant(worldIn.getBlockState(pos.down()), worldIn, pos.down(), EnumFacing.UP, this) || block == mcreator_tomatoPlant.block);
		}

		@SideOnly(Side.CLIENT)
		public int colorMultiplier(IBlockAccess p_149720_1_, BlockPos pos, int pass) {
			return 16777215;
		}

		@Override
		public void updateTick(World worldIn, BlockPos pos, IBlockState state, Random p_149674_5_) {
			if (worldIn.getBlockState(pos.down()).getBlock() == block || this.checkForDrop(worldIn, pos, state)) {
				if (worldIn.isAirBlock(pos.up())) {
					int l;
					for (l = 1; worldIn.getBlockState(pos.down(l)).getBlock() == this; ++l) {
						;
					}
					if (l < 2) {
						int i1 = ((Integer) state.getValue(AGE)).intValue();
						if (i1 == 15) {
							worldIn.setBlockState(pos.up(), this.getDefaultState());
							worldIn.setBlockState(pos, state.withProperty(AGE, Integer.valueOf(0)), 4);
						} else {
							worldIn.setBlockState(pos, state.withProperty(AGE, Integer.valueOf(i1 + 1)), 4);
						}
					}
				}
			}
		}

		@Override
		public int quantityDropped(Random par1Random) {
			return 2;
		}

		@Override
		public Item getItemDropped(IBlockState state, Random rand, int fortune) {
			return new ItemStack(mcreator_tomato.block).getItem();
		}
	}
}